####################################################################
# Please executes the following steps to build 
# your own uboot image
#####################################################################

#*****************************************************
# Step1: Choice your Chip Type
#*****************************************************
#PLATFORM_TYPE = ASIC_SHUTTLE
PLATFORM_TYPE = ASIC_MP
#PLATFORM_TYPE = FPGA_SHUTTLE
#PLATFORM_TYPE = FPGA_MP

#********************************************************************
# Step2: Choice your GMAC Mode (Mode1 or Mode2 or Mode3)
#********************************************************************
#-------------------------------
#  Mode-1: Focus 100/Full Link On state 
#  Connect to: IC+175C/D, IC+PHY...etc
#-------------------------------
GMAC_MODE = MAC_TO_100PHY_MODE

# IC+ 175 C/D: port based VLAN 
# (P0~P4: Demo Board=WLLLL, EV Board=LLLLW)
#PORT_BASED_VLAN = RALINK_DEMO_BOARD_PVLAN
#PORT_BASED_VLAN = RALINK_EV_BOARD_PVLAN

#------------------------------
#  Mode-2: Focus 1000/Full Link On state 
#  Connect to : Vitesse Switch, RTK Switch...etc
#-------------------------------
#GMAC_MODE = MAC_TO_GIGAMAC_MODE

# Vitesse Switch need to turn on
#SWITH_RESET_MODE = GPIO10_RESET_MODE
#GIGA_SWITCH = VITESSE_7395

#-------------------------------
#  Mode-3: Auto-polling
#  Connect to: Marvell GigaPhy...etc
#------------------------------
#GMAC_MODE = MAC_TO_GIGAPHY_MODE

# Auto-Negotiation GigaPHY Address 
#MAC_TO_GIGAPHY_MODE_ADDR = 0x1

#********************************************************************
# Step3: Choice your DRAM Size
#********************************************************************
DRAM_COMPONENT = 64M
#DRAM_COMPONENT = 128M

#DRAM_BUS= 16BIT
DRAM_BUS= 32BIT


#********************************************************************
# Step4: Choice your Flash Size
#********************************************************************
FLASH_COMPONENT = 4M
#FLASH_COMPONENT = 2M


######################################################################
# Option setting
######################################################################
#----------------------------------------
# uboot image type
#----------------------------------------
# ROM version (Burn to Flash)
TEXT_BASE = 0xBFC00000
# RAM version (Download to DRAM using JTAG)
#TEXT_BASE = 0x8A200000

#----------------------------------------
#If your GPIO14 connect to hardware reset circuit, 
#you can turn on the definition to reset whole board 
#if cpu_reset, system_reset or wdg_reset occured
#----------------------------------------
#BOARD_RESET_MODE = GPIO14_RESET_MODE

######################################################################




#################<< Test function option Configuration >>###################

# Set with ON/OFF

UN_NECESSITY_U_BOOT_CMD_OPEN = OFF

######## RT2880 test function option configuration ##########################

# Set with ON/OFF
RT2880_RUN_COMMAD_AT_ETH_RCV_FUN = OFF
RT2880_PCI_HOST_TEST_FUN = OFF
RT2880_MDIO_ACCESS_FUN = ON
RT2880_MEMORY_TEST_FUN = OFF
RT2880_GDMA_STATUS_DISPLAY_FUN = OFF
RT2880_GDMA_SCATTER_TEST_FUN = OFF
RT2880_GDMA_DUP_TX_RING_TEST_FUN = OFF
RT2880_MUTI_TX_DESCRIPTOR_TEST_FUN = OFF
RT2880_CACHE_STATE_DETECT_FUNC = OFF
RT2880_SEGMENT_SIZE_ALIGN_TEST_FUNC = OFF
RT2880_INTERNAL_LOOPBACK_TEST_FUNC = OFF
RT2880_SDRAM_CONTROLLER_REFRESH_CYCLE_TEST_FUNC = OFF

##########################################################################

# clean the slate ...
PLATFORM_RELFLAGS =
PLATFORM_CPPFLAGS =
PLATFORM_LDFLAGS =

#
# When cross-compiling on NetBSD, we have to define __PPC__ or else we
# will pick up a va_list declaration that is incompatible with the
# actual argument lists emitted by the compiler.
#
# [Tested on NetBSD/i386 1.5 + cross-powerpc-netbsd-1.3]

ifeq ($(ARCH),ppc)
ifeq ($(CROSS_COMPILE),powerpc-netbsd-)
PLATFORM_CPPFLAGS+= -D__PPC__
endif
ifeq ($(CROSS_COMPILE),powerpc-openbsd-)
PLATFORM_CPPFLAGS+= -D__PPC__
endif
endif

ifeq ($(ARCH),arm)
ifeq ($(CROSS_COMPILE),powerpc-netbsd-)
PLATFORM_CPPFLAGS+= -D__ARM__
endif
ifeq ($(CROSS_COMPILE),powerpc-openbsd-)
PLATFORM_CPPFLAGS+= -D__ARM__
endif
endif

ifdef	ARCH
sinclude $(TOPDIR)/$(ARCH)_config.mk	# include architecture dependend rules
endif
ifdef	CPU
sinclude $(TOPDIR)/cpu/$(CPU)/config.mk	# include  CPU	specific rules
endif
ifdef	SOC
sinclude $(TOPDIR)/cpu/$(CPU)/$(SOC)/config.mk	# include  SoC	specific rules
endif
ifdef	VENDOR
BOARDDIR = $(VENDOR)/$(BOARD)
else
BOARDDIR = $(BOARD)
endif
ifdef	BOARD
sinclude $(TOPDIR)/board/$(BOARDDIR)/config.mk	# include board specific rules
endif

#########################################################################

CONFIG_SHELL	:= $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
		    else if [ -x /bin/bash ]; then echo /bin/bash; \
		    else echo sh; fi ; fi)

ifeq ($(HOSTOS)-$(HOSTARCH),darwin-ppc)
HOSTCC		= cc
else
HOSTCC		= gcc
endif
HOSTCFLAGS	= -Wall -Wstrict-prototypes -g -fomit-frame-pointer
HOSTSTRIP	= strip

#########################################################################

#
# Include the make variables (CC, etc...)
#
AS	= $(CROSS_COMPILE)as
LD	= $(CROSS_COMPILE)ld
CC	= $(CROSS_COMPILE)gcc
CPP	= $(CC) -E
AR	= $(CROSS_COMPILE)ar
NM	= $(CROSS_COMPILE)nm
STRIP	= $(CROSS_COMPILE)strip
OBJCOPY = $(CROSS_COMPILE)objcopy
OBJDUMP = $(CROSS_COMPILE)objdump
RANLIB	= $(CROSS_COMPILE)RANLIB

RELFLAGS= $(PLATFORM_RELFLAGS)
DBGFLAGS= -g #-DDEBUG
OPTFLAGS= -Os #-fomit-frame-pointer
ifndef LDSCRIPT
#LDSCRIPT := $(TOPDIR)/board/$(BOARDDIR)/u-boot.lds.debug
LDSCRIPT := $(TOPDIR)/board/$(BOARDDIR)/u-boot.lds
endif
OBJCFLAGS += --gap-fill=0xff

gccincdir := $(shell $(CC) -print-file-name=include)


CPPFLAGS := $(DBGFLAGS) $(OPTFLAGS) $(RELFLAGS)		\
	-D__KERNEL__ -DTEXT_BASE=$(TEXT_BASE) 		\
	-I$(TOPDIR)/include				\
	-fno-builtin -ffreestanding -nostdinc -isystem	\
	$(gccincdir) -pipe $(PLATFORM_CPPFLAGS)
#	-DROUTER100					\


ifeq ($(UN_NECESSITY_U_BOOT_CMD_OPEN),ON)
CPPFLAGS += -DRT2880_U_BOOT_CMD_OPEN

endif


ifeq ($(RT2880_RUN_COMMAD_AT_ETH_RCV_FUN),ON)
CPPFLAGS += -DRT2880_RUN_COMMAD_AT_ETH_RCV_FUN
endif

ifeq ($(RT2880_PCI_HOST_TEST_FUN),ON)
CPPFLAGS += -DRT2880_PCI_HOST_TEST_FUN
endif
ifeq ($(RT2880_MDIO_ACCESS_FUN),ON)
CPPFLAGS += -DRT2880_MDIO_ACCESS_FUN
endif

ifeq ($(RT2880_MEMORY_TEST_FUN),ON)
CPPFLAGS += -DRT2880_MEMORY_TEST_FUN
endif

ifeq ($(RT2880_GDMA_STATUS_DISPLAY_FUN),ON)
CPPFLAGS += -DRT2880_GDMA_STATUS_DISPLAY_FUN
endif

ifeq ($(RT2880_GDMA_SCATTER_TEST_FUN),ON)
CPPFLAGS += -DRT2880_GDMA_SCATTER_TEST_FUN
endif

ifeq ($(RT2880_GDMA_DUP_TX_RING_TEST_FUN),ON)
CPPFLAGS += -DRT2880_GDMA_DUP_TX_RING_TEST_FUN
endif

ifeq ($(RT2880_GDMA_DUP_TX_RING_TEST_FUN),ON)
CPPFLAGS += -DRT2880_MUTI_TX_DESCRIPTOR_TEST_FUN
endif


ifeq ($(RT2880_CACHE_STATE_DETECT_FUNC),ON)
CPPFLAGS += -DRT2880_CACHE_STATE_DETECT_FUNC
endif

ifeq ($(RT2880_SEGMENT_SIZE_ALIGN_TEST_FUNC),ON)
CPPFLAGS += -DRT2880_SEGMENT_SIZE_ALIGN_TEST_FUNC
endif

ifeq ($(RT2880_INTERNAL_LOOPBACK_TEST_FUNC),ON)
CPPFLAGS += -DRT2880_INTERNAL_LOOPBACK_TEST_FUNC
endif

ifeq ($(RT2880_SDRAM_CONTROLLER_REFRESH_CYCLE_TEST_FUNC),ON)
CPPFLAGS += -DRT2880_SDRAM_CONTROLLER_REFRESH_CYCLE_TEST_FUNC
endif


ifeq ($(PLATFORM_TYPE),ASIC_SHUTTLE)
CPPFLAGS += -DEV_BOARD
else
ifeq ($(PLATFORM_TYPE),ASIC_MP)
CPPFLAGS += -DEV_BOARD
CPPFLAGS += -DRT2880_FPGA_B_VER_BOARD
else
ifeq ($(PLATFORM_TYPE),FPGA_MP)
CPPFLAGS += -DRT2880_FPGA_B_VER_BOARD
CPPFLAGS += -DFPGA_BOARD_RT2880
else
ifeq ($(PLATFORM_TYPE),FPGA_SHUTTLE)
CPPFLAGS += -DFPGA_BOARD_RT2880
endif
endif
endif
endif


ifeq ($(GMAC_MODE),MAC_TO_GIGAMAC_MODE)
CPPFLAGS += -DMAC_TO_GIGAMAC_MODE
endif

ifeq ($(GMAC_MODE),MAC_TO_GIGAPHY_MODE)
CPPFLAGS += -DMAC_TO_GIGAPHY_MODE
endif

ifdef MAC_TO_GIGAPHY_MODE_ADDR
CPPFLAGS += -DMAC_TO_GIGAPHY_MODE_ADDR=$(MAC_TO_GIGAPHY_MODE_ADDR)
endif 

ifeq ($(GMAC_MODE),MAC_TO_100PHY_MODE)
CPPFLAGS += -DMAC_TO_100PHY_MODE
endif

ifeq ($(SWITH_RESET_MODE),GPIO10_RESET_MODE)
CPPFLAGS += -DGPIO10_RESET_MODE
endif

ifeq ($(BOARD_RESET_MODE),GPIO14_RESET_MODE)
CPPFLAGS += -DGPIO14_RESET_MODE
endif

ifeq ($(FORCE_MODE),FORCE_TO_100F)
CPPFLAGS += -DFORCE_TO_100F
endif

ifeq ($(GIGA_SWITCH),VITESSE_7395)
CPPFLAGS += -DVTSS_SWITCH_SUPPORT
endif

ifeq ($(PORT_BASED_VLAN),RALINK_DEMO_BOARD_PVLAN)
CPPFLAGS += -DRALINK_DEMO_BOARD_PVLAN
endif
ifeq ($(PORT_BASED_VLAN),RALINK_EV_BOARD_PVLAN)
CPPFLAGS += -DRALINK_EV_BOARD_PVLAN
endif

ifeq ($(DRAM_BUS),16BIT)
CPPFLAGS += -DON_BOARD_16BIT_DRAM_BUS
else
ifeq ($(DRAM_BUS),32BIT)
CPPFLAGS += -DON_BOARD_32BIT_DRAM_BUS
endif
endif

ifeq ($(DRAM_COMPONENT),64M)
CPPFLAGS += -DON_BOARD_64M_DRAM_COMPONENT
else
ifeq ($(DRAM_COMPONENT),128M)
CPPFLAGS += -DON_BOARD_128M_DRAM_COMPONENT
endif
endif


ifeq ($(FLASH_COMPONENT),2M)
CPPFLAGS += -DON_BOARD_2M_FLASH_COMPONENT
else
ifeq ($(FLASH_COMPONENT),4M)
CPPFLAGS += -DON_BOARD_4M_FLASH_COMPONENT
endif
endif


	
ifdef BUILD_TAG
CFLAGS := $(CPPFLAGS) -Wall -Wstrict-prototypes \
	-DBUILD_TAG='"$(BUILD_TAG)"'
else
CFLAGS := $(CPPFLAGS) -Wall -Wstrict-prototypes
endif

# avoid trigraph warnings while parsing pci.h (produced by NIOS gcc-2.9)
# this option have to be placed behind -Wall -- that's why it is here
ifeq ($(ARCH),nios)
ifeq ($(findstring 2.9,$(shell $(CC) --version)),2.9)
CFLAGS := $(CPPFLAGS) -Wall -Wno-trigraphs
endif
endif

AFLAGS_DEBUG := -Wa,-gstabs
AFLAGS := $(AFLAGS_DEBUG) -D__ASSEMBLY__ $(CPPFLAGS)

LDFLAGS += -Bstatic -T $(LDSCRIPT) -Ttext $(TEXT_BASE) $(PLATFORM_LDFLAGS)

# Location of a usable BFD library, where we define "usable" as
# "built for ${HOST}, supports ${TARGET}".  Sensible values are
# - When cross-compiling: the root of the cross-environment
# - Linux/ppc (native): /usr
# - NetBSD/ppc (native): you lose ... (must extract these from the
#   binutils build directory, plus the native and U-Boot include
#   files don't like each other)
#
# So far, this is used only by tools/gdb/Makefile.

ifeq ($(HOSTOS)-$(HOSTARCH),darwin-ppc)
BFD_ROOT_DIR =		/usr/local/tools
else
ifeq ($(HOSTARCH),$(ARCH))
# native
BFD_ROOT_DIR =		/usr
else
#BFD_ROOT_DIR =		/LinuxPPC/CDK		# Linux/i386
#BFD_ROOT_DIR =		/usr/pkg/cross		# NetBSD/i386
BFD_ROOT_DIR =		/opt/powerpc
endif
endif

#########################################################################

export	CONFIG_SHELL HPATH HOSTCC HOSTCFLAGS CROSS_COMPILE \
	AS LD CC CPP AR NM STRIP OBJCOPY OBJDUMP \
	MAKE
export	TEXT_BASE PLATFORM_CPPFLAGS PLATFORM_RELFLAGS CPPFLAGS CFLAGS AFLAGS
#########################################################################

%.s:	%.S
	$(CPP) $(AFLAGS) -o $@ $(CURDIR)/$<
%.o:	%.S
	$(CC) $(AFLAGS) -c -o $@ $(CURDIR)/$<
%.o:	%.c
	$(CC) $(CFLAGS) -c -o $@ $<

#########################################################################
